use gtk4 as gtk;
use gtk::{glib, prelude::*, subclass::prelude::*};

mod imp {
    use super::*;
    use glib::subclass::Signal;
    use once_cell::sync::Lazy;
    
    #[derive(Debug, Default, gtk::CompositeTemplate)]
    #[template(file = "data/main_panel.blp")]
    pub struct MainPanel {
        #[template_child]
        pub overlay: TemplateChild<gtk::Overlay>,
    }

    #[gtk::template_callbacks]
    impl MainPanel {
        
    }

    #[glib::object_subclass]
    impl ObjectSubclass for MainPanel {
        const NAME: &'static str = "MainPanel";
        type Type = super::MainPanel;
        type ParentType = gtk::Box;

        fn class_init(class: &mut Self::Class) {
            class.bind_template();
            class.bind_template_callbacks();
        }

        fn instance_init(obj: &glib::subclass::InitializingObject<Self>) {
            obj.init_template();
        }
    }

    impl ObjectImpl for MainPanel {
        fn signals() -> &'static [Signal] {
            static SIGNALS: Lazy<Vec<Signal>> = Lazy::new(||
                vec![Signal::builder("logged-out").build(),
                    Signal::builder("api-key-cleared").build()]);
            SIGNALS.as_ref()
        }
    }

    impl BoxImpl for MainPanel {}
    impl WidgetImpl for MainPanel {}
}

glib::wrapper! {
    pub struct MainPanel(ObjectSubclass<imp::MainPanel>)
    @extends gtk::Widget, @implements gtk::Accessible,
    gtk::Buildable, gtk::ConstraintTarget, gtk::Orientable;
}
